/*
Copyright (c) 2012, David Liu
All rights reserved. Read the license for more information.
*/

/* Definitions */
#define CSND_PUSH 0
#define CSOUNDS 1
unsigned long CChan[CSOUNDS];
#define CVOL_MAX 10000
#define CVOL_MUTE 0

/* Functions */
bool CEngine::CEnableSound()
{
    if (HIWORD(BASS_GetVersion())!=BASSVERSION) // Check version
	{
		CMsgBox("Incorrect version of BASS was loaded.","Error");
		return false;
	}
    #if defined(COS_WIN32)
	if (!BASS_Init(-1,44100,0,hWnd,NULL))
	{
		CMsgBox("Unable to initialize the sound output device.","Error");
		return false;
	}
    #elif defined(COS_LINUX)
	if (!BASS_Init(-1,44100,0,NULL,NULL))
	{
		CMsgBox("Unable to initialize the sound output device.","Error");
		return false;
	}
    #endif
	// Load engine sounds
	if (!CLoadSound("engine/sc_push.wav",&CChan[CSND_PUSH],false))
	{
		CMsgBox(inerr,"Error");
		return false;
	}
	return true;
}

bool CEngine::CLoadSound(const char*path,unsigned long*chan,bool loop)
{
	strcpy(outerr,rootpath);
	// Load stream
	if ((*chan=BASS_StreamCreateFile(false,strcat(outerr,path),0,0,BASS_SAMPLE_MONO)))
	{
		if (loop&&BASS_ChannelFlags(*chan,BASS_SAMPLE_LOOP,BASS_SAMPLE_LOOP)==-1)
		{
			 strcpy(inerr,"Unable to configure this sound file.");
			return false;
		}
		return true;
	}
	else
	{
		strcpy(inerr,"Unable to find/load sound file.");
		return false;
	}
}

void CEngine::CStartSound(unsigned long*chan) {BASS_ChannelPlay(*chan,false);}

void CEngine::CPauseSound(unsigned long*chan) {BASS_ChannelPause(*chan);}

void CEngine::CStopSound(unsigned long*chan)
{
	BASS_ChannelPause(*chan);
	BASS_ChannelSetPosition(*chan,0,BASS_POS_BYTE);
}

void CEngine::CSoundVol(const unsigned short vol) {BASS_SetConfig(BASS_CONFIG_GVOL_STREAM,vol);}
