/* Functions */
void MoveWndSys()
{
	if (core.key[CKEY_RMOUSE])
	{
		if (app.pmx==-1)
		{
			app.pmx=core.mx;
			app.pmy=core.my;
		}
        core.CMoveWindow(core.xpos+core.mx-app.pmx,core.ypos+app.pmy-core.my,APPWIDTH,APPHEIGHT);
	}
	else if (app.pmx!=-1)
		app.pmx=-1;
}

void SetupScripter()
{
	// Setup
	strcpy(cmdfunction[0].name,"SetAttributes");
	strcpy(cmdfunction[0].format,"ifff");
	strcpy(cmdfunction[1].name,"LoadOBJ");
	strcpy(cmdfunction[1].format,"si");
	strcpy(cmdfunction[2].name,"LoadBMP");
	strcpy(cmdfunction[2].format,"siii");
	strcpy(cmdfunction[3].name,"LoadTGA");
	strcpy(cmdfunction[3].format,"siiii");
	strcpy(cmdfunction[4].name,"CreateVariable");
	strcpy(cmdfunction[4].format,"sf");
	// Render
	strcpy(cmdfunction[5].name,"RenderModel");
	strcpy(cmdfunction[5].format,"i");
	strcpy(cmdfunction[6].name,"PushMatrix");
	strcpy(cmdfunction[6].format,"");
	strcpy(cmdfunction[7].name,"PopMatrix");
	strcpy(cmdfunction[7].format,"");
	strcpy(cmdfunction[8].name,"Rotate");
	strcpy(cmdfunction[8].format,"ffff");
	strcpy(cmdfunction[9].name,"Translate");
	strcpy(cmdfunction[9].format,"fff");
	strcpy(cmdfunction[10].name,"Scale");
	strcpy(cmdfunction[10].format,"fff");
	strcpy(cmdfunction[11].name,"Texture");
	strcpy(cmdfunction[11].format,"i");
	strcpy(cmdfunction[12].name,"Vertex");
	strcpy(cmdfunction[12].format,"fff");
	strcpy(cmdfunction[13].name,"TexCoord");
	strcpy(cmdfunction[13].format,"ff");
	strcpy(cmdfunction[14].name,"VertexFormat");
	strcpy(cmdfunction[14].format,"s");
	strcpy(cmdfunction[15].name,"VertexEnd");
	strcpy(cmdfunction[15].format,"");
	strcpy(cmdfunction[16].name,"Enable");
	strcpy(cmdfunction[16].format,"s");
	strcpy(cmdfunction[17].name,"Disable");
	strcpy(cmdfunction[17].format,"s");
	strcpy(cmdfunction[18].name,"LightAttribs");
	strcpy(cmdfunction[18].format,"sffff");
	strcpy(cmdfunction[19].name,"Color");
	strcpy(cmdfunction[19].format,"ffff");
	strcpy(cmdfunction[20].name,"InterVariable");
	strcpy(cmdfunction[20].format,"ff");
	strcpy(cmdfunction[21].name,"ModVariable");
	strcpy(cmdfunction[21].format,"ffs");
	// Process
	strcpy(cmdfunction[22].name,"ProcVariable");
	strcpy(cmdfunction[22].format,"ffs");
}

void CleanBenchmark()
{
	unsigned int i;
	// Exit
	if (bench.lines!=NULL)
	{
		CLoops(i,bench.length)
		{
			delete[] bench.lines[i];
		}
		delete[] bench.lines;
	}
	if (bench.setupcmds!=NULL)
		delete[] bench.setupcmds;
	if (bench.rendercmds!=NULL)
		delete[] bench.rendercmds;
	if (bench.processcmds!=NULL)
		delete[] bench.processcmds;
	if (bench.model!=NULL)
		delete[] bench.model;
	if (bench.tex!=NULL)
	{
		glDeleteTextures(bench.texcnt,bench.tex);
		delete[] bench.tex;
	}
	if (bench.intsav!=NULL)
		delete[] bench.intsav;
	if (bench.charsav!=NULL)
	{
		if (bench.charalloc)
		{
			CLoops(i,bench.charsavcnt-1)
			{
				delete[] bench.charsav[i];
			}
		}
		delete[] bench.charsav;
	}
	if (bench.floatptr!=NULL)
		delete[] bench.floatptr;
	if (bench.floatsav!=NULL)
		delete[] bench.floatsav;
	if (vars!=NULL)
		delete[] vars;
}

void StartBenchmark(unsigned char cnt)
{
	// Loading frame
	glLoadIdentity();
	glTranslatef(0.0f,0.0f,-1.0f);
	glClear(GL_COLOR_BUFFER_BIT);
	core.CPrintText("Loading...",1.0f,1.0f,CGuicol_s,CFONT_TEXT);
	core.CSwapBuffers();
	// Initialize
	app.benchmode=true;
	bench.fps=bench.avgfps=bench.fpspeak=0.0;
	bench.cntfps=0;
	bench.setupcmds=NULL;
	bench.rendercmds=NULL;
	bench.processcmds=NULL;
	bench.floatptr=NULL;
	bench.intsav=NULL;
	bench.floatsav=NULL;
	bench.charsav=NULL;
	bench.model=NULL;
	bench.tex=NULL;
	vars=NULL;
	bench.charalloc=false;
	// Default values
	bench.frame=40000; // 25 UPD
	bench.badfps=30.0f;
	bench.goodfps=60.0f;
	bench.fov=75.0f;
	// Parse benchmark script
	if (!ParseScript(app.benchnames[cnt]))
		app.benchmode=false;
	// Set global code counters
	bench.floatptrcnt=bench.intsavcnt=bench.floatsavcnt=0; // floatsav substitutes charsav, charsav is saved for memory cleaning
	// Execute setup script
	if (app.benchmode)
	{
		unsigned int i;
		if (bench.modelcnt>0)
			bench.model=new cmodel[bench.modelcnt];
		if (bench.texcnt>0)
			bench.tex=new ctexture[bench.texcnt];
		CLoops(i,bench.setupcmdcnt)
		{
			if (bench.setupcmds[i]==CMD_setattributes)
			{
				bench.frame=bench.intsav[bench.intsavcnt];
				bench.badfps=(*bench.floatptr[bench.floatptrcnt]);
				bench.goodfps=(*bench.floatptr[bench.floatptrcnt+1]);
				bench.fov=(*bench.floatptr[bench.floatptrcnt+2]);
				bench.floatptrcnt+=3;
				bench.intsavcnt++;
			}
			else if (bench.setupcmds[i]==CMD_loadobj)
			{
				if (!core.CLoadOBJ(bench.charsav[bench.floatsavcnt],bench.model[bench.intsav[bench.intsavcnt]]))
				{
					strcpy(bench.msgbuffer,core.inerr);
					app.benchmode=false;
					break;
				}
				bench.intsavcnt++;
				bench.floatsavcnt++;
			}
			else if (bench.setupcmds[i]==CMD_loadbmp)
			{
				if (!core.CLoadBMP(bench.charsav[bench.floatsavcnt],bench.tex[bench.intsav[bench.intsavcnt]],(bool)bench.intsav[bench.intsavcnt+1],(bool)bench.intsav[bench.intsavcnt+2]))
				{
					strcpy(bench.msgbuffer,core.inerr);
					app.benchmode=false;
					break;
				}
				bench.intsavcnt+=3;
				bench.floatsavcnt++;
			}
			else if (bench.setupcmds[i]==CMD_loadtga)
			{
				if (!core.CLoadTGA(bench.charsav[bench.floatsavcnt],bench.tex[bench.intsav[bench.intsavcnt]],(bool)bench.intsav[bench.intsavcnt+1],(bool)bench.intsav[bench.intsavcnt+2],(bool)bench.intsav[bench.intsavcnt+3]))
				{
					strcpy(bench.msgbuffer,core.inerr);
					app.benchmode=false;
					break;
				}
				bench.intsavcnt+=4;
				bench.floatsavcnt++;
			}
			else if (bench.setupcmds[i]==CMD_createvariable)
			{
				// Already executed in ReadFunction
				bench.floatsavcnt++;
				bench.floatptrcnt++;
			}
		}
	}
	// Error message
	if (!app.benchmode)
	{
		core.CToggleCursor(true);
		while (1)
		{
			core.CProcessMessage();
			glClear(GL_COLOR_BUFFER_BIT);
			core.CPrintText(bench.msgbuffer,0.5f,3.0f,CGuicol_w,CFONT_TEXT);
			if (core.CPushbutton("OK",1.0f,1.0f))
				break;
			MoveWndSys();
			core.CSwapBuffers();
			core.CSleep(APPFRAME);
		}
		// Return
		CleanBenchmark();
		return;
	}
	// Prepare benchmark
	app.savxpos=core.xpos;
	app.savypos=core.ypos;
	app.lefttime=0;
	core.CMoveWindow(0,0);
	core.CResize3D(core.width,core.height,bench.fov);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	core.CToggleCursor(false);
	app.prevtime=bench.savtime=core.CGetTime();
}

void QuitBenchmark()
{
	// Ensure default CEngine OpenGL states
	core.CToggleCursor(true);
	if (glIsEnabled(GL_DEPTH_TEST))
		glDisable(GL_DEPTH_TEST);
	if (glIsEnabled(GL_CULL_FACE))
		glDisable(GL_CULL_FACE);
	if (!glIsEnabled(GL_TEXTURE_2D))
		glEnable(GL_TEXTURE_2D);
	if (!glIsEnabled(GL_BLEND))
		glEnable(GL_BLEND);
	if (glIsEnabled(GL_LIGHTING))
	{
		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT0);
	}
	core.CMoveWindow(app.savxpos,app.savypos,APPWIDTH,APPHEIGHT);
	core.CResize2D(core.width,core.height,10.0f,10.0f);
	// Loading frame
	glLoadIdentity();
	glTranslatef(0.0f,0.0f,-1.0f);
	glClear(GL_COLOR_BUFFER_BIT);
	core.CPrintText("Loading...",1.0f,1.0f,CGuicol_s,CFONT_TEXT);
	core.CSwapBuffers();
	// Clean
	CleanBenchmark();
	const float*colbuf;
	// Display
	while (1)
	{
		core.CProcessMessage();
		glClear(GL_COLOR_BUFFER_BIT);
		core.CPrintText("Results",1.0f,8.5f,CGuicol_w,CFONT_TEXT);
		// avg fps
		core.CPrintText("Average frames per second:",1.0f,7.5f,CGuicol_s,CFONT_TEXT);
		if (bench.avgfps<bench.badfps)
			colbuf=&CGuicol_r[0];
		else if (bench.avgfps<bench.goodfps)
			colbuf=&CGuicol_y[0];
		else
			colbuf=&CGuicol_g[0];
		core.CPrintValue(bench.avgfps,1,7.5f,7.5f,colbuf,CFONT_TEXT);
		// peak fps
		core.CPrintText("Peak frames per second:",1.0f,6.5f,CGuicol_s,CFONT_TEXT);
		if (bench.fpspeak<bench.badfps)
			colbuf=&CGuicol_r[0];
		else if (bench.fpspeak<bench.goodfps)
			colbuf=&CGuicol_y[0];
		else
			colbuf=&CGuicol_g[0];
		core.CPrintValue(bench.fpspeak,1,7.5f,6.5f,colbuf,CFONT_TEXT);
		// ups
		core.CPrintText("Updates per second:",1.0f,5.5f,CGuicol_s,CFONT_TEXT);
		core.CPrintValue(1000000.0/(double)bench.frame,1,7.5f,5.5f,CGuicol_s,CFONT_TEXT);
		if (core.CPushbutton("OK",1.0f,1.0f))
			break;
		MoveWndSys();
		core.CSwapBuffers();
		core.CSleep(APPFRAME);
	}
	// Return
	app.benchmode=false;
	app.prevtime=app.lefttime=0;
}

void ShowFPS()
{
	int i=0;
	glDisable(GL_DEPTH_TEST);
	if (!glIsEnabled(GL_TEXTURE_2D))
	{
		glEnable(GL_TEXTURE_2D);
		i++;
	}
	if (!glIsEnabled(GL_BLEND))
	{
		glEnable(GL_BLEND);
		i+=3;
	}
	if (glIsEnabled(GL_LIGHTING))
	{
		glDisable(GL_LIGHTING);
		i+=5;
	}
	bench.fps=1000000.0/(core.CGetTime()-bench.savtime);
	if (bench.fps>bench.fpspeak)
		bench.fpspeak=bench.fps;
	bench.cntfps++;
	bench.avgfps=(bench.avgfps*(bench.cntfps-1)+bench.fps)/bench.cntfps;
	core.CResize2D(core.width,core.height);
	core.CPrintValue(bench.fps,1,1.0f,1.0f);
	core.CPrintText("Press esc to exit.",14.0f,1.0f,CGuicol_s);
	core.CResize3D(core.width,core.height,bench.fov);
	if (i==1||i==4||i==6||i==9)
		glDisable(GL_TEXTURE_2D);
	if (i==3||i==4||i>=8)
		glDisable(GL_BLEND);
	if (i==5||i==6||i>=8)
		glEnable(GL_LIGHTING);
	glEnable(GL_DEPTH_TEST);
}

/*
Identity matrix:
camera looking into -z axes.
x axes if left/right.
y axes is up/down.
*/

void BenchRender(float interpolate)
{
	unsigned int i;
	// Reset command counters
	bench.intsavcnt=bench.sintcnt;
	bench.floatptrcnt=bench.sfloatcnt;
	bench.floatsavcnt=bench.scharcnt;
	// Standard frame code
	glClear(GL_COLOR_BUFFER_BIT);
	if (glIsEnabled(GL_DEPTH_TEST))
		glClear(GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glPushMatrix();
	// Execute main commands
	CLoops(i,bench.rendercmdcnt)
	{
		if (bench.rendercmds[i]==CMD_rendermodel)
		{
			core.CRenderModel(bench.model[bench.intsav[bench.intsavcnt]]);
			bench.intsavcnt++;
		}
		else if (bench.rendercmds[i]==CMD_pushmatrix)
			glPushMatrix();
		else if (bench.rendercmds[i]==CMD_popmatrix)
			glPopMatrix();
		else if (bench.rendercmds[i]==CMD_rotate)
		{
			glRotatef(*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2],*bench.floatptr[bench.floatptrcnt+3]);
			bench.floatptrcnt+=4;
		}
		else if (bench.rendercmds[i]==CMD_translate)
		{
			glTranslatef(*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2]);
			bench.floatptrcnt+=3;
		}
		else if (bench.rendercmds[i]==CMD_scale)
		{
			glScalef(*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2]);
			bench.floatptrcnt+=3;
		}
		else if (bench.rendercmds[i]==CMD_texture)
		{
			glBindTexture(GL_TEXTURE_2D,bench.tex[bench.intsav[bench.intsavcnt]]);
			bench.intsavcnt++;
		}
		else if (bench.rendercmds[i]==CMD_vertex)
		{
			glVertex3f(*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2]);
			bench.floatptrcnt+=3;
		}
		else if (bench.rendercmds[i]==CMD_texcoord)
		{
			glTexCoord2f(*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1]);
			bench.floatptrcnt+=2;
		}
		else if (bench.rendercmds[i]==CMD_vertexformat)
		{
			if (strcmp(bench.charsav[bench.floatsavcnt],"quads")==0)
				glBegin(GL_QUADS);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"triangles")==0)
				glBegin(GL_TRIANGLES);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"tri_strip")==0)
				glBegin(GL_TRIANGLE_STRIP);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"polygons")==0)
				glBegin(GL_POLYGON);
			bench.floatsavcnt++;
		}
		else if (bench.rendercmds[i]==CMD_vertexend)
			glEnd();
		else if (bench.rendercmds[i]==CMD_enable)
		{
			if (strcmp(bench.charsav[bench.floatsavcnt],"blend")==0)
				glEnable(GL_BLEND);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"depth")==0)
				glEnable(GL_DEPTH_TEST);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"texture")==0)
				glEnable(GL_TEXTURE_2D);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"cullface")==0)
				glEnable(GL_CULL_FACE);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"light")==0)
			{
				glEnable(GL_LIGHTING);
				glEnable(GL_LIGHT0);
			}
			bench.floatsavcnt++;
		}
		else if (bench.rendercmds[i]==CMD_disable)
		{
			if (strcmp(bench.charsav[bench.floatsavcnt],"blend")==0)
				glDisable(GL_BLEND);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"depth")==0)
				glDisable(GL_DEPTH_TEST);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"texture")==0)
				glDisable(GL_TEXTURE_2D);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"cullface")==0)
				glDisable(GL_CULL_FACE);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"light")==0)
			{
				glDisable(GL_LIGHTING);
				glDisable(GL_LIGHT0);
			}
			bench.floatsavcnt++;
		}
		else if (bench.rendercmds[i]==CMD_lightattribs)
		{
			if (strcmp(bench.charsav[bench.floatsavcnt],"position")==0)
			{
				float pos[4]={*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2],*bench.floatptr[bench.floatptrcnt+3]};
				glLightfv(GL_LIGHT0,GL_POSITION,pos);
			}
			else if (strcmp(bench.charsav[bench.floatsavcnt],"diffuse")==0)
			{
				float dif[4]={*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2],*bench.floatptr[bench.floatptrcnt+3]};
				glLightfv(GL_LIGHT0,GL_DIFFUSE,dif);
			}
			else if (strcmp(bench.charsav[bench.floatsavcnt],"specular")==0)
			{
				float spec[4]={*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2],*bench.floatptr[bench.floatptrcnt+3]};
				glLightfv(GL_LIGHT0,GL_SPECULAR,spec);
			}
			else if (strcmp(bench.charsav[bench.floatsavcnt],"ambient")==0)
			{
				float amb[4]={*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2],*bench.floatptr[bench.floatptrcnt+3]};
				glLightfv(GL_LIGHT0,GL_AMBIENT,amb);
			}
			bench.floatptrcnt+=4;
			bench.floatsavcnt++;
		}
		else if (bench.rendercmds[i]==CMD_color)
		{
			glColor4f(*bench.floatptr[bench.floatptrcnt],*bench.floatptr[bench.floatptrcnt+1],*bench.floatptr[bench.floatptrcnt+2],*bench.floatptr[bench.floatptrcnt+3]);
			bench.floatptrcnt+=4;
		}
		else if (bench.rendercmds[i]==CMD_intervariable)
		{
			(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt+1])*interpolate;
			bench.floatptrcnt+=2;
		}
		else if (bench.rendercmds[i]==CMD_modvariable)
		{
			if (strcmp(bench.charsav[bench.floatsavcnt],"+")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])+(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"-")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])-(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"*")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])*(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"/")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])/(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"=")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt+1]);
			bench.floatptrcnt+=2;
			bench.floatsavcnt++;
		}
	}
	// FPS
	glPopMatrix();
	ShowFPS();
	// Render
	core.CSwapBuffers();
	bench.savtime=core.CGetTime();
}

void BenchProcess()
{
	// Storage
	unsigned int i;
	// Reset command counters
	bench.intsavcnt=bench.sintcnt2;
	bench.floatptrcnt=bench.sfloatcnt2;
	bench.floatsavcnt=bench.scharcnt2;
	// Execute process commands
	CLoops(i,bench.processcmdcnt)
	{
		if (bench.processcmds[i]==CMD_procvariable)
		{
			if (strcmp(bench.charsav[bench.floatsavcnt],"+")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])+(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"-")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])-(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"*")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])*(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"/")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt])/(*bench.floatptr[bench.floatptrcnt+1]);
			else if (strcmp(bench.charsav[bench.floatsavcnt],"=")==0)
				(*bench.floatptr[bench.floatptrcnt])=(*bench.floatptr[bench.floatptrcnt+1]);
			bench.floatptrcnt+=2;
			bench.floatsavcnt++;
		}
	}
	if (core.key[CKEY_ESC])
		QuitBenchmark();
}
