/* Definitions */
CEngine core;

struct Application
{
	bool quit;
	unsigned short page;
	float barcol[3];
	float extscrl,benchscrl;
	float rot;
	char extfind[30];
	bool extclick;
	unsigned short extpos;
	bool opt1;
	char str1[4];
	int benchcnt;
	char**benchnames;
	bool benchmode;
	int pmx,pmy,savxpos,savypos;
	unsigned long long prevtime;
	int lefttime;
};
Application app;
enum{P_MENU,
P_DATA,
P_GLEXT,
P_MARKS,
P_OPTIONS,
P_ABOUT};
#define APPWIDTH 450
#define APPHEIGHT 275
#define APPFRAME 20000
#define EXTLEN 50
#define GLCHECK_VERSION "1.0"

struct GLData
{
	char*glversion,*glslversion,*implementor,*renderer,*glxversion,**extensions;
	unsigned short extcnt;
	unsigned int extlen;
};
GLData gldata;

struct Bench
{
	// Data
	char**names;
	char msgbuffer[50];
	unsigned int setupcmdcnt,rendercmdcnt,processcmdcnt,length,comments;
	unsigned char*setupcmds,*rendercmds,*processcmds;
	unsigned int modelcnt,texcnt;
	unsigned char varcnt;
	ctexture*tex;
	int frame;
	cmodel*model;
	char**lines;
	double fps,avgfps,fpspeak;
	float fov;
	unsigned long long savtime;
	unsigned long cntfps;
	float badfps,goodfps;
	// Storage for variables
	unsigned int floatptrcnt;
	float**floatptr;
	unsigned char varorder;
	// Storage for arguments
	unsigned int intsavcnt,floatsavcnt,charsavcnt;
	unsigned int sintcnt,sfloatcnt,scharcnt;
	unsigned int sintcnt2,sfloatcnt2,scharcnt2;
	bool charalloc;
	int*intsav;
	float*floatsav;
	char**charsav;
};
Bench bench;
// Setup commands
#define SETUPCMDTYPES 5
#define CMD_setattributes 0
#define CMD_loadobj 1
#define CMD_loadbmp 2
#define CMD_loadtga 3
#define CMD_createvariable 4
// Main commands
#define MAINCMDTYPES 17
#define CMD_rendermodel 0
#define CMD_pushmatrix 1
#define CMD_popmatrix 2
#define CMD_rotate 3
#define CMD_translate 4
#define CMD_scale 5
#define CMD_texture 6
#define CMD_vertex 7
#define CMD_texcoord 8
#define CMD_vertexformat 9
#define CMD_vertexend 10
#define CMD_enable 11
#define CMD_disable 12
#define CMD_lightattribs 13
#define CMD_color 14
#define CMD_intervariable 15
#define CMD_modvariable 16
// Process commands
#define PROCESSCMDTYPES 1
#define CMD_procvariable 0
// Parser lengths
#define SCRIPT_PATH 31 // 30 chars + \0
#define SCRIPT_FUNC 16 // 15 chars + \0
#define SCRIPT_NAME 11 // 10 chars + \0
#define SCRIPT_VAR 6 // 5 chars + \0
#define SCRIPT_ARGS 6 // Maximum arguments per function
// Functions
struct Function
{
	char name[SCRIPT_FUNC];
	char format[SCRIPT_ARGS+1];
};
#define TOTALCMDTYPES 23
Function cmdfunction[TOTALCMDTYPES];
// Variables
struct Variable
{
	char name[SCRIPT_VAR];
	float value;
};
Variable*vars;
