/* Functions */
void RenderGLSym()
{
	glDisable(GL_TEXTURE_2D);
	glPushMatrix();
	glTranslatef(7.2f,4.5f,0.0f);
	glRotatef(app.rot,0.0f,0.0f,1.0f);
	glBegin(GL_TRIANGLES);
	glColor3f(1.0f,0.0f,0.0f);glVertex2d(-1.6f,0.0f);
	glColor3f(0.0f,1.0f,0.0f);glVertex2d(1.0f,1.4f);
	glColor3f(0.0f,0.0f,1.0f);glVertex2d(1.0f,-1.4f);
	glEnd();
	glPopMatrix();
	glEnable(GL_TEXTURE_2D);
	app.rot+=0.75f;
	if (app.rot>360.0f)
		app.rot-=360.0f;
}

void SaveOpt()
{
	strcpy(core.outerr,core.rootpath);
	ofstream userfile(strcat(core.outerr,"data/userfile.cfg"));
	if (userfile.is_open())
	{
		userfile << (int)app.opt1;
		userfile.close();
	}
	else
		core.CMsgBox("Unable to open userfile.cfg. Cannot save userdata.","Error");
}

/* Pages */
inline void Menu()
{
	CFrame
	(
		core.CPrintText("Open",1.7f,7.8f,CGuicol_r,CFONT_SUBT);
		core.CPrintText("GL",3.7f,7.8f,CGuicol_b,CFONT_SUBT);
		core.CPrintText("Checker",4.7f,7.8f,CGuicol_g,CFONT_SUBT);
		if (core.CPushbutton("Properties",2.3f,6.2f,CGuicol_b))
			app.page=P_DATA;
		if (core.CPushbutton("Extensions",2.3f,4.8f,CGuicol_b))
			app.page=P_GLEXT;
		if (core.CPushbutton("Benchmarks",2.3f,3.4f,CGuicol_b))
			app.page=P_MARKS;
		if (core.CPushbutton("Options",2.3f,2.0f,CGuicol_b))
			app.page=P_OPTIONS;
		if (core.CPushbutton("About",2.3f,0.6f,CGuicol_b))
			app.page=P_ABOUT;
		if (core.CPushbutton("x",-0.05f,9.2f,CGuicol_r))
			app.quit=true;
		RenderGLSym();
	)
	MoveWndSys();
	core.CSwapBuffers();
}

inline void Data()
{
	CFrame
	(
		if (core.CPushbutton("Back",-0.1f,9.05f,CGuicol_r))
			app.page=P_MENU;
		core.CPrintText("GL version:",0.5f,8.0f,CGuicol_y,CFONT_TEXT);
		core.CPrintText(gldata.glversion,0.5f,7.25f,CGuicol_w,CFONT_TEXT);
		core.CPrintText("GLSL version:",0.5f,6.5f,CGuicol_y,CFONT_TEXT);
		core.CPrintText(gldata.glslversion,0.5f,5.75f,CGuicol_w,CFONT_TEXT);
		core.CPrintText("GLX version:",0.5f,5.0f,CGuicol_y,CFONT_TEXT);
		core.CPrintText(gldata.glxversion,0.5f,4.25f,CGuicol_w,CFONT_TEXT);
		core.CPrintText("Renderer:",0.5f,3.5f,CGuicol_y,CFONT_TEXT);
		core.CPrintText(gldata.renderer,0.5f,2.75f,CGuicol_w,CFONT_TEXT);
		core.CPrintText("Implementor:",0.5f,2.0f,CGuicol_y,CFONT_TEXT);
		core.CPrintText(gldata.implementor,0.5f,1.25f,CGuicol_w,CFONT_TEXT);
	)
	MoveWndSys();
	core.CSwapBuffers();
}

inline void About()
{
	CFrame
	(
		if (core.CPushbutton("Back",-0.1f,9.05f,CGuicol_r))
			app.page=P_MENU;
		core.CPrintText("OpenGLChecker version:",0.5f,8.0f,CGuicol_y);
		core.CPrintText(GLCHECK_VERSION,5.55f,8.0f,CGuicol_w);
		core.CPrintText("CEngine version:",0.5f,7.0f,CGuicol_y);
		core.CPrintText(CENGINE_VERSION,4.25f,7.0f,CGuicol_w);
		core.CPrintText("OpenGLChecker is an application developed",0.5f,5.75f,CGuicol_w);
		core.CPrintText("to let the user find information about ",0.5f,5.0f,CGuicol_w);
		core.CPrintText("his/her OpenGL implementation easily.",0.5f,4.25f,CGuicol_w);
		core.CPrintText("OpenGLChecker runs on the CEngine, a ",0.5f,3.5f,CGuicol_w);
		core.CPrintText("cross platform OpenGL engine written in ",0.5f,2.75f,CGuicol_w);
		core.CPrintText("C/C++. OpenGLChecker and the CEngine ",0.5f,2.0f,CGuicol_w);
		core.CPrintText("are written and developed by David Liu.",0.5f,1.25f,CGuicol_w);
	)
	MoveWndSys();
	core.CSwapBuffers();
}

inline void Extensions()
{
	unsigned short i;
	double yv;
	CFrame
	(
		if (core.CPushbutton("Back",-0.1f,9.05f,CGuicol_r))
			app.page=P_MENU;
		if (gldata.extcnt>0)
		{
			if (gldata.extcnt>10)
				core.CScrollV(0.1f,0.3f,8.4f,&app.extscrl,0.0f,(gldata.extcnt-1)*0.75f);
			// Lookup function
			if ((app.extfind[0]=='\0'||app.extfind[0]==' ')&&!app.extclick)
			{
				app.extpos=0;
				strcpy(app.extfind,"Find...");
			}
			core.CInputbar(1.75f,8.9f,7.75f,app.extfind,30,&app.extclick,&app.extpos,CGuicol_s);
			if (app.extclick)
			{
				if (strcmp(app.extfind,"Find...")==0)
					memset(app.extfind,0,sizeof(app.extfind));
				bool*valid;
				valid=new bool[gldata.extcnt];
				CLoops(i,gldata.extcnt)
				{
					valid[i]=true;
				}
				unsigned short i2;
				int sav;
				CLoops(i2,30)
				{
					// Check valid extensions and find first one
					if (app.extfind[i2]!='\0')
					{
						sav=-1;
						CLoops(i,gldata.extcnt)
						{
							if (strlen(gldata.extensions[i])+1>i2&&gldata.extensions[i][i2]==app.extfind[i2]&&valid[i])
							{
								if (sav==-1)
								{
									sav=i;
									app.extscrl=i*0.75f;
								}
							}
							else
								valid[i]=false;
						}
						// All extensions invalid?
						CLoops(i,gldata.extcnt+1)
						{
							if (i<gldata.extcnt&&valid[i])
								break;
						}
						if (i==gldata.extcnt)
							break;
					}
					else
						break;
				}
				delete[] valid;
			}
			// Display
			CLoops(i,gldata.extcnt)
			{
				yv=8.0f+int(app.extscrl/0.75f)*0.75f-0.75f*i;
				if (yv<=8.0f&&yv>=1.25f)
					core.CPrintText(gldata.extensions[i],0.75f,yv,CGuicol_w);
			}
			core.CPrintText("Total supported extensions:",0.75f,0.35f,CGuicol_y);
			core.CPrintValue(gldata.extcnt,0,6.95f,0.35f,CGuicol_w);
		}
		else
			core.CPrintText("No supported extensions.",0.5f,8.0f,CGuicol_w);
	)
	MoveWndSys();
	core.CSwapBuffers();
}

inline void Options()
{
	CFrame
	(
		if (core.CPushbutton("Back",-0.1f,9.05f,CGuicol_r))
		{
			SaveOpt();
			app.page=P_MENU;
		}
		core.CPrintText("Sound:",0.5f,8.0f,CGuicol_y);
		if (core.CPushbutton(app.str1,2.0f,7.8f,CGuicol_g))
		{
			if (app.opt1)
			{
				core.CSoundVol(CVOL_MUTE);
				app.opt1=false;
				strcpy(app.str1,"Off");
			}
			else
			{
				core.CSoundVol(CVOL_MAX);
				app.opt1=true;
				strcpy(app.str1,"On");
			}
		}
	)
	MoveWndSys();
	core.CSwapBuffers();
}

inline void Benchmarks()
{
	unsigned char cnt,point;
	short start=-1;
	CFrame
	(
		if (app.benchcnt>7)
			core.CScrollV(0.1f,0.3f,8.4f,&app.benchscrl,0.0f,app.benchcnt-7);
		if (core.CPushbutton("Back",-0.1f,9.05f,CGuicol_r))
			app.page=P_MENU;
		CLoops(cnt,app.benchcnt)
		{
			if (cnt>=(int)app.benchscrl)
			{
				point=strlen(app.benchnames[cnt])-4;
				app.benchnames[cnt][point]='\0';
				core.CPrintText(app.benchnames[cnt],0.8f,8.0f-1.2f*cnt+(int)app.benchscrl*1.2f);
				if (core.CPushbutton("Start!",7.5f,7.8-1.2f*cnt+(int)app.benchscrl*1.2f))
					start=cnt;
				app.benchnames[cnt][point]='.';
			}
		}
		if (app.benchcnt==0)
            core.CPrintText("No benchmark files found.",0.5f,8.0f);
	)
	MoveWndSys();
	core.CSwapBuffers();
	if (start>-1)
		StartBenchmark(start);
}
