/* Functions */
bool CheckFunction(const char*line,unsigned int curline) // Count and initialize functions
{
	char funcname[SCRIPT_FUNC];
	unsigned char i,loop=0;
	short funcid=-1;
	char atline[14];
	sprintf(atline,"%d",curline);
	// Function name
	CLoops(i,strlen(line)+1)
	{
		if (isspace(line[i])||line[i]=='\0')
		{
			funcname[loop]='\0';
			break;
		}
		if (i==SCRIPT_FUNC-1)
		{
			strcpy(bench.msgbuffer,"In line ");
			strcat(bench.msgbuffer,atline);
			strcat(bench.msgbuffer,": Invalid function name.");
			return false;
		}
		funcname[loop]=line[i];
		loop++;
	}
	CLoops(i,TOTALCMDTYPES)
	{
		if (strcmp(cmdfunction[i].name,funcname)==0)
		{
			funcid=i;
			break;
		}
	}
	if (funcid==-1)
	{
		strcpy(bench.msgbuffer,"In line ");
		strcat(bench.msgbuffer,atline);
		strcat(bench.msgbuffer,": Function does not exist.");
		return false;
	}
	if (funcid>=SETUPCMDTYPES+MAINCMDTYPES)
	{
		bench.processcmds[bench.intsavcnt]=funcid-SETUPCMDTYPES-MAINCMDTYPES;
		bench.intsavcnt++;
	}
	else if (funcid>=SETUPCMDTYPES)
	{
		bench.rendercmds[bench.floatsavcnt]=funcid-SETUPCMDTYPES;
		bench.floatsavcnt++;
	}
	else
	{
		bench.setupcmds[bench.charsavcnt]=funcid;
		bench.charsavcnt++;
	}
	// Count functions
	if (funcid==CMD_createvariable)
		bench.varcnt++;
	else if (funcid==CMD_loadobj)
		bench.modelcnt++;
	else if (funcid==CMD_loadbmp||funcid==CMD_loadtga)
		bench.texcnt++;
	return true;
}

bool CountArguments(char*line,unsigned int curline) // Count and parse arguments
{
	char funcname[SCRIPT_FUNC],argname[SCRIPT_PATH];
	unsigned char curchar,i,loop=0,cnt=0,funcid;
	char atline[14];
	sprintf(atline,"%d",curline);
	bool number;
	// Function name
	CLoops(i,strlen(line)+1)
	{
		if (isspace(line[i])||line[i]=='\0')
		{
			funcname[loop]='\0';
			curchar=i+1;
			break;
		}
		funcname[loop]=line[i];
		loop++;
	}
	CLoops(i,TOTALCMDTYPES)
	{
		if (strcmp(cmdfunction[i].name,funcname)==0)
		{
			funcid=i;
			break;
		}
	}
	// Read the arguments
	i=curchar;
	while (i<strlen(line))
	{
		if (cnt==strlen(cmdfunction[funcid].format))
		{
			strcpy(bench.msgbuffer,"In line ");
			strcat(bench.msgbuffer,atline);
			strcat(bench.msgbuffer,": Too many arguments.");
			return false;
		}
		// Get the argument of function
		loop=0;
		number=true;
		CLoopc(i,curchar,SCRIPT_PATH+curchar,1)
		{
			if (isspace(line[i])||line[i]=='\0')
			{
				argname[loop]='\0';
				if (loop==0)
				{
					strcpy(bench.msgbuffer,"In line ");
					strcat(bench.msgbuffer,atline);
					strcat(bench.msgbuffer,": Empty argument.");
					return false;
				}
				if (argname[loop-1]=='-')
					number=false;
				curchar=i+1;
				break;
			}
			if (i==SCRIPT_PATH-1+curchar) // Last character, reserved for \0
			{
				strcpy(bench.msgbuffer,"In line ");
				strcat(bench.msgbuffer,atline);
				strcat(bench.msgbuffer,": Argument is too long.");
				return false;
			}
			argname[loop]=line[i];
			if (number&&isdigit(argname[loop])==0&&argname[loop]!='.'&&argname[loop]!='-')
				number=false;
			loop++;
		}
		// Determine type and process
		if (cmdfunction[funcid].format[cnt]=='f') // Floating point number
		{
			if (!number)
			{
				if (strlen(argname)>SCRIPT_VAR-1)
				{
					strcpy(bench.msgbuffer,"In line ");
					strcat(bench.msgbuffer,atline);
					strcat(bench.msgbuffer,": Variable is too long.");
					return false;
				}
			}
			else
				bench.floatsavcnt++;
			bench.floatptrcnt++;
		}
		else if (cmdfunction[funcid].format[cnt]=='s') // String
		{
			if (number)
			{
				strcpy(bench.msgbuffer,"In line ");
				strcat(bench.msgbuffer,atline);
				strcat(bench.msgbuffer,": Argument must be a string.");
				return false;
			}
			bench.charsavcnt++;
		}
		else // Integer
		{
			if (!number)
			{
				strcpy(bench.msgbuffer,"In line ");
				strcat(bench.msgbuffer,atline);
				strcat(bench.msgbuffer,": Argument must be an integer.");
				return false;
			}
			bench.intsavcnt++;
		}
		cnt++;
	}
	if (cnt<strlen(cmdfunction[funcid].format))
	{
		strcpy(bench.msgbuffer,"In line ");
		strcat(bench.msgbuffer,atline);
		strcat(bench.msgbuffer,": Missing arguments.");
		return false;
	}
	return true;
}

bool ReadFunction(const char*line,unsigned int curline) // Collect all arguments
{
	// Init
	unsigned char i,loop=0,curchar,funcid,cnt=0;
	bool number;
	char funcname[SCRIPT_FUNC],argname[SCRIPT_PATH];
	char atline[14];
	sprintf(atline,"%d",curline);
	// Function name
	CLoops(i,strlen(line)+1)
	{
		if (isspace(line[i])||line[i]=='\0')
		{
			funcname[loop]='\0';
			curchar=i+1;
			break;
		}
		funcname[loop]=line[i];
		loop++;
	}
	CLoops(i,TOTALCMDTYPES)
	{
		if (strcmp(cmdfunction[i].name,funcname)==0)
		{
			funcid=i;
			break;
		}
	}
	// Read the arguments
	i=curchar;
	while (i<strlen(line))
	{
		// Get the argument of function
		loop=0;
		number=true;
		CLoopc(i,curchar,SCRIPT_PATH+curchar,1)
		{
			if (isspace(line[i])||line[i]=='\0')
			{
				argname[loop]='\0';
				curchar=i+1;
				break;
			}
			else
			{
				argname[loop]=line[i];
				if (number&&isdigit(argname[loop])==0&&argname[loop]!='.'&&argname[loop]!='-')
					number=false;
			}
			loop++;
		}
		// Determine type and process
		if (cmdfunction[funcid].format[cnt]=='f') // Floating point number
		{
			if (number)
			{
				sscanf(argname,"%f",&bench.floatsav[bench.floatsavcnt]);
				bench.floatptr[bench.floatptrcnt]=&bench.floatsav[bench.floatsavcnt];
				bench.floatsavcnt++;
			}
			else
			{
				loop=bench.varcnt;
				CLoops(loop,bench.varcnt)
				{
					if (strcmp(vars[loop].name,argname)==0)
					{
						bench.floatptr[bench.floatptrcnt]=&vars[loop].value;
						break;
					}
				}
				if (loop==bench.varcnt)
				{
					strcpy(bench.msgbuffer,"In line ");
					strcat(bench.msgbuffer,atline);
					strcat(bench.msgbuffer,": Variable not defined.");
					return false;
				}
			}
			bench.floatptrcnt++;
		}
		else if (cmdfunction[funcid].format[cnt]=='s') // String
		{
			if (!bench.charalloc)
				bench.charalloc=true;
			bench.charsav[bench.charsavcnt]=new char[strlen(argname)+1];
			strcpy(bench.charsav[bench.charsavcnt],argname);
			bench.charsavcnt++;
		}
		else // Integer
		{
			sscanf(argname,"%d",&bench.intsav[bench.intsavcnt]);
			bench.intsavcnt++;
		}
		cnt++;
	}
	// Execute if createvariable
	if (funcid==CMD_createvariable)
	{
		CLoops(i,bench.varcnt) // Check for duplicate
		{
			if (strcmp(bench.charsav[bench.charsavcnt-1],vars[i].name)==0)
			{
				strcpy(bench.msgbuffer,"In line ");
				strcat(bench.msgbuffer,atline);
				strcat(bench.msgbuffer,": Variable already defined.");
				return false;
			}
		}
		strcpy(vars[bench.varorder].name,bench.charsav[bench.charsavcnt-1]);
		vars[bench.varorder].value=(*bench.floatptr[bench.floatptrcnt-1]);
		bench.varorder++;
	}
	return true;
}

bool ParseScript(const char*name)
{
	// Read file
	unsigned int i;
	bench.length=bench.comments=0;
	strcpy(core.outerr,core.rootpath);strcat(core.outerr,"benchmarks/");
	ifstream datafile(strcat(core.outerr,name),ios::binary);
	if (datafile.is_open())
	{
		// Count lines
		unsigned long beg,end,size;
		beg=datafile.tellg();
		datafile.seekg(0,ios::end);
		end=datafile.tellg();
		datafile.seekg(0,ios::beg);
		size=end-beg;
		if (size==0)
		{
			datafile.close();
			strcpy(bench.msgbuffer,"Loading an empty datafile.");
			return false;
		}
		char*sav=new char[size+1];
		datafile.read(sav,size);
		sav[size]='\0';
		if (!datafile)
		{
			delete[] sav;
			datafile.close();
			strcpy(bench.msgbuffer,"Unable to read all data successfully.");
			return false;
		}
		// Remove comments
		bool comment=false;
		unsigned int curline=0;
		CLoops(beg,size)
		{
			if (sav[beg]=='#')
				comment=true;
			else if (sav[beg]=='\n')
			{
				if (!comment)
					curline++;
				else
				{
					comment=false;
					bench.comments++;
				}
			}
		}
		bench.lines=new char*[curline];
		// Allocate arrays
		end=curline=0;
		CLoops(beg,size)
		{
			if (sav[beg]=='#')
				comment=true;
			else if (sav[beg]=='\n')
			{
				if (!comment)
				{
					i=beg-end+1;
					bench.lines[curline]=new char[i];
					end=beg+1;
					curline++;
				}
				else
				{
					comment=false;
					end=beg+1;
				}
			}
		}
		// Assign data to arrays
		end=curline=0;
		unsigned long loop;
		CLoops(beg,size)
		{
			if (sav[beg]=='#')
				comment=true;
			else if (sav[beg]=='\n')
			{
				if (!comment)
				{
					i=0;
					CLoopc(loop,end,beg,1)
					{
						bench.lines[curline][i]=sav[loop];
						i++;
					}
					bench.lines[curline][i-1]='\0';
					end=beg+1;
					curline++;
				}
				else
				{
					comment=false;
					end=beg+1;
				}
			}
		}
		bench.length=curline;
		delete[] sav;
		datafile.close();
	}
	else
	{
		strcpy(bench.msgbuffer,"Unable to open the benchmark file.");
		return false;
	}
	bench.intsavcnt=bench.length;
	bench.floatsavcnt=bench.length;
	CLoops(i,bench.length)
	{
		if (strcmp(bench.lines[i],"render:")==0)
		{
			bench.floatsavcnt=i;
			break;
		}
	}
	if (bench.floatsavcnt==bench.length)
	{
		strcpy(bench.msgbuffer,"No render entry detected.");
		return false;
	}
	CLoopc(i,bench.floatsavcnt,bench.length,1)
	{
		if (strcmp(bench.lines[i],"process:")==0)
		{
			bench.intsavcnt=i;
			break;
		}
	}
	if (bench.intsavcnt==bench.length)
	{
		strcpy(bench.msgbuffer,"No process entry detected.");
		return false;
	}
	bench.setupcmdcnt=bench.floatsavcnt;
	bench.rendercmdcnt=bench.intsavcnt-1-bench.floatsavcnt;
	bench.processcmdcnt=bench.length-1-bench.intsavcnt;
	if (bench.setupcmdcnt>0)
		bench.setupcmds=new unsigned char[bench.setupcmdcnt];
	if (bench.rendercmdcnt>0)
		bench.rendercmds=new unsigned char[bench.rendercmdcnt];
	if (bench.processcmdcnt>0)
		bench.processcmds=new unsigned char[bench.processcmdcnt];
	bench.comments++;
	// Parse functions
	bench.intsavcnt=bench.floatsavcnt=bench.charsavcnt=0; // use as temp storage counters
	bench.modelcnt=bench.texcnt=bench.varcnt=0;
	CLoops(i,bench.length)
	{
		if (i!=bench.setupcmdcnt&&i!=bench.setupcmdcnt+bench.rendercmdcnt+1)
		{
			if (!CheckFunction(bench.lines[i],i+bench.comments))
				return false;
		}
	}
	// Allocate variables
	if (bench.varcnt>0)
		vars=new Variable[bench.varcnt];
	// Parse arguments
	bench.floatptrcnt=bench.intsavcnt=bench.floatsavcnt=bench.charsavcnt=0;
	CLoops(i,bench.length)
	{
		if (i!=bench.setupcmdcnt&&i!=bench.setupcmdcnt+bench.rendercmdcnt+1)
		{
			if (!CountArguments(bench.lines[i],i+bench.comments))
				return false;
			// Store counters
			if (i<bench.setupcmdcnt)
			{
				bench.sintcnt=bench.intsavcnt;
				bench.sfloatcnt=bench.floatptrcnt;
				bench.scharcnt=bench.charsavcnt;
			}
			else if (i<=bench.setupcmdcnt+bench.rendercmdcnt)
			{
				bench.sintcnt2=bench.intsavcnt;
				bench.sfloatcnt2=bench.floatptrcnt;
				bench.scharcnt2=bench.charsavcnt;
			}
		}
	}
	// Allocate argument data
	if (bench.floatptrcnt>0)
		bench.floatptr=new float*[bench.floatptrcnt];
	if (bench.floatsavcnt>0)
		bench.floatsav=new float[bench.floatsavcnt];
	if (bench.intsavcnt>0)
		bench.intsav=new int[bench.intsavcnt];
	if (bench.charsavcnt>0)
		bench.charsav=new char*[bench.charsavcnt];
	// Assign code
	bench.floatptrcnt=bench.intsavcnt=bench.floatsavcnt=bench.charsavcnt=bench.varorder=0;
	CLoops(i,bench.length)
	{
		if (i!=bench.setupcmdcnt&&i!=bench.setupcmdcnt+bench.rendercmdcnt+1)
		{
			if (!ReadFunction(bench.lines[i],i+bench.comments))
				return false;
		}
	}
	// Delete buffer
	CLoops(i,bench.length)
	{
		delete[] bench.lines[i];
	}
	delete[] bench.lines;
	bench.lines=NULL;
	return true;
}
